-- do not modify

FilterData = class();

function FilterData:Constructor()
	-- DuplicationPolicy (used to detect duplicated text in the channel)
	self.ChatHistorySize              = 10;    -- chat history size
	self.ChatHistoryIndex             = 0;     -- current index to use
	self.ChatHistoryCache             = {};    -- array

	-- GoldsellerPolicy
	self.SpamHeuristic                = {};
	self.SpamHeuristic.Threshold      = 2;     -- max symbol or word to find before block
	self.SpamHeuristic.Words          = {"USD", "EUR"};
	self.SpamHeuristic.Symbols        = {"!!", "$", "€", "PAY.COM"};

	-- BlacklistPolicy (bouncer, based on text)
	self.BlackListThreshold           = 50;    -- max items in the list before clearing
	self.BlackList                    = {};    -- set
	self.BlackListTimeMax             = 300;   -- 5 minutes expiration

	-- QualityPolicy
	self.ChatQuality                  = 0;     -- the normal quality average of all posts
	self.ChatQualityCounter           = 0;     -- number of posts inspected
	self.ChatQualityThreshold         = 0.5;   -- the post should have more then the half quality to pass
	self.ChatQualityMaxTrash          = 10;    -- the post should have words, not trash like "b y e g o l d i m s e r i o u s";
	self.ChatMessageLength            = 0;     -- average
	self.ChatMessageCounter           = 0;

	-- UserPolicy (used to detect frequently users)
	self.UserHistorySize              = 10;    -- user/chat history size
	self.UserHistoryIndex             = 0;     -- current index to use
	self.UserHistoryCache             = {};    -- array
	self.UserHistoryThreshold         = 0.5;   -- more than 50% posts in the chat history

	-- Development
	self.Debug                        = false; -- Debug output
	self.TraceSpam                    = false; -- Display short [Spam][World] Text ... Message
	self.Active                       = true;  -- State, filter works only on active state

	-- Policies
	self.Policies = {};
	self.Policies.BlacklistPolicy     = true;  -- enabled
	self.Policies.DuplicationPolicy   = true;  -- enabled
	self.Policies.UserPolicy          = true;  -- enabled
	self.Policies.QualityPolicy       = true;  -- enabled
	self.Policies.SpamPolicy          = true;  -- enabled
	self.Policies.GoldsellerPolicy    = true;  -- enabled

	-- Statistics
	self.NumMessagesTaken             = 0;     -- number of messages taken
	self.NumMessagesBlocked           = 0;     -- number of messages blocked
	self.BlockedByPolicy              = {};    -- number of messages blocked by policy

	-- Channels (not really a part of the filter engine)
	self.Channels = {Turbine.ChatType.World, Turbine.ChatType.Trade};
end
