
Main = class();

function Main:Constructor()
    local filterData = FilterData();
	local filterEngine = FilterEngine(filterData);
	local shellCommandHandler = ShellCommandHandler(filterEngine);

	self.SpamFilter = SpamFilter(filterEngine);
	self.OptionsPanel = UI.OptionsPanel(filterEngine);
	self.ShellCommand = ShellCommand(shellCommandHandler);
end

function Main:OnLoad()
	if self.ShellCommand:RegisterCommandName("spam") ~= true then
		local uniqueName = string.lower(plugin:GetAuthor() .. "." .. plugin:GetName() .. "." .. plugin:GetVersion());
		self.ShellCommand:RegisterCommandName(uniqueName);
	end	

	Settings:Load();
end

function Main:OnUnload()
	Settings:Save();
	self.ShellCommand:UnregisterCommandName();
end

function Main:OnChatMessage(message, chatType)
	self.SpamFilter:HandleMessage(message, chatType);
end

function Main:GetOptionsPanel()
	return self.OptionsPanel;
end
