
UserPolicy = class();

function UserPolicy:Constructor(filterData)
	self.Name = "UserPolicy";
	self.Data = filterData;
end

function UserPolicy:Execute(message, channel, username, text)
	local usercount = 0;
	local threshold = self.Data.UserHistorySize * self.Data.UserHistoryThreshold;

	for _, user in pairs(self.Data.UserHistoryCache) do
		-- High frequently user (maybe Spam)
		if user == username then
			usercount = usercount + 1;

			if usercount > threshold then
				self:DebugOut("frequently user (" .. usercount .. ")");
				-- detected
				return true;
			end
		end
	end
end

function UserPolicy:Apply(message, channel, username, text, blocked, policyName)
	if blocked == true then
		-- don't remember
		return;
	end

	-- remember the user
	self.Data.UserHistoryIndex = (self.Data.UserHistoryIndex + 1) % self.Data.UserHistorySize;
	self.Data.UserHistoryCache[self.Data.UserHistoryIndex] = username;
end

function UserPolicy:DebugOut(message)
	if self.Data.Debug then
		Turbine.Shell.WriteLine(self.Name .. ":> " .. message);
	end
end
