
SpamFilter = class();

function SpamFilter:Constructor(filterEngine)
	self.Engine = filterEngine;
	
	Events.AddCallback(self.Engine, "DebugChanged", function(sender, args)
		Turbine.Shell.WriteLine("SpamFilter:> debug is turned " .. (args and "on" or "off"));
	end);

	Events.AddCallback(self.Engine, "TraceSpamChanged", function(sender, args)
		Turbine.Shell.WriteLine("SpamFilter:> trace spam is turned " .. (args and "on" or "off"));
	end);

	Events.AddCallback(self.Engine, "ActiveChanged", function(sender, args)
		Turbine.Shell.WriteLine("SpamFilter:> spam filter is turned " .. (args and "on" or "off"));
	end);

	Events.AddCallback(self.Engine, "PolicyStateChanged", function(sender, args)
		Turbine.Shell.WriteLine("SpamFilter:> " .. args.Name .. " is " .. (args.Value and "enabled" or "disabled"));
	end);
end

function SpamFilter:HandleMessage(message, chatType)
	-- Wants to handle specific channels only
	if self.Engine:DoHandleChatType(chatType) ~= true then
		-- Not for that channel
		return;
	end

	if self.Engine:ProcessMessage(message) ~= true then
		-- Blocked
		if self.Engine:IsTraceSpamEnabled() then
			self:TraceSpam(message);
		end

		return;
	end

	-- Passed
	-- Show the message
	self:TextOut(message);
end

function SpamFilter:TextOut(message)
	-- Remove line breaks
	message = string.gsub(message, "[\r\n]", "");

	Turbine.Shell.WriteLine('<rgb=#f0f0f0>' .. message .. '</rgb>');
end

function SpamFilter:TraceSpam(message)
	-- Remove tags and limit the output
	message = string.gsub(message, "<[^>]+>", "");
	message = string.sub(message, 1, 50);

	self:TextOut('[Spam] <rgb=#b90002>' .. message .. ' ...</rgb>');
end

