
_G.Border = class(LayoutBase);

_G.BorderStyle = 
{
	["BackColor"] = Turbine.UI.Color(0.9, 0.0, 0.0, 0.0),
	["BorderColor"] = Turbine.UI.Color(1, 0.3, 0.3, 0.3),
};

function Border:Constructor()
	LayoutBase.Constructor(self);
	
	-- content
	local content = TemplateLoader.Setup(self, self:GetTemplate());
	content:SetParent(self);
	self.Content = content;

	-- self
	self:SetSize(self.Content:GetSize());
end

function Border:SetContent(control)
	self.InnerPanel:SetContent(control);
	return self.InnerPanel;
end

function Border:SetBackColor(color)
	self.InnerPanel:SetBackColor(color);
end

function Border:SetBorderColor(color)
	self.OuterPanel:SetBackColor(color);
end

function Border:SetBorderWidth(value)
	if type(value) == "table" then
		self.OuterPanel.ContentStyle.Padding.Left   = math.max(0, value.Left   or self.OuterPanel.ContentStyle.Padding.Left);
		self.OuterPanel.ContentStyle.Padding.Top    = math.max(0, value.Top    or self.OuterPanel.ContentStyle.Padding.Top);
		self.OuterPanel.ContentStyle.Padding.Right  = math.max(0, value.Right  or self.OuterPanel.ContentStyle.Padding.Right);
		self.OuterPanel.ContentStyle.Padding.Bottom = math.max(0, value.Bottom or self.OuterPanel.ContentStyle.Padding.Bottom);
		return;
	end

	value = math.max(0, value or 0);
	self.OuterPanel.ContentStyle:SetPadding(value, value, value, value);
end

function Border:Layout()
	self.OuterPanel:SetSize(self:GetSize());
	self.OuterPanel:PerformLayout();
	self:SetSize(self.OuterPanel:GetSize());
	--self:PerformLayout();
end

function Border:GetTemplate(bindings)
	return {
		["Type"] = ContentControl,
		["Name"] = "OuterPanel",
		["BackColor"] = BorderStyle.BorderColor,
		["Content"] =
		{
			{
				["Type"] = ContentControl,
				["Name"] = "InnerPanel",
				["BackColor"] = BorderStyle.BackColor,
				["Content"] =
				{
				},
			},
		},
	};
end
