
_G.CheckBox = class(LayoutBase);

function CheckBox:Constructor()
	LayoutBase.Constructor(self);

	-- content
	local content = TemplateLoader.Setup(self, self:GetTemplate());
	content:SetParent(self);
	self.Content = content;

	-- self
	self:SetSize(content:GetSize());
end

function CheckBox:SetText(text)
	self.TextBlock:SetText(text);
end

function CheckBox:Layout()
	self.Panel:SetSize(self:GetSize());
	self.Panel:PerformLayout();
	self:SetSize(self.Panel:GetSize());
	--self:PerformLayout();
end

function CheckBox:MouseClick(args)
	self:ToggleState();
end

function CheckBox:SetChecked(value)
	self.CheckBox:SetChecked(value);
end

function CheckBox:IsChecked()
	return self.CheckBox:IsChecked();
end

function CheckBox:ToggleState()
	self:SetChecked(not self:IsChecked());
end

function CheckBox:GetTemplate(bindings)
	return {
		["Type"] = StackPanel,
		["Name"] = "Panel",
		["Width"] = 100,
		["Content"] =
		{
			{
				["Type"] = StackPanel,
				["Name"] = "InnerPanel",
				["IsVertical"] = false,
				["FitToContent"] = false,
				["Content.DynamicHeight"] = 1,
				["Content.VerticalAlignment"] = VerticalAlignment.Center,
				["Content"] =
				{
					{
						["Type"] = Turbine.UI.Lotro.CheckBox,
						["Name"] = "CheckBox",
						["Text"] = "",
						["Width"] = 20,
						["Height"] = 20,
						["Content.MaxHeight"] = 20,
						["Content.VerticalAlignment"] = VerticalAlignment.Top,
					},
					{
						["Type"] = TextBlock,
						["Name"] = "TextBlock",
						["Text"] = "",
						["Height"] = 20,
						["Content.VerticalAlignment"] = VerticalAlignment.Top,
						["Content.DynamicWidth"] = 1,
					},
				},
			},
		}
	};
end
