
_G.VerticalAlignment = {
	["None"] = 0,
	["Stretch"] = 0,
	["Top"] = 1,
	["Center"] = 2,
	["Bottom"] = 3,
};

_G.HorizontalAlignment = {
	["None"] = 0,
	["Stretch"] = 0,
	["Left"] = 1,
	["Center"] = 2,
	["Right"] = 3,
}

_G.ContentStyle = class();

function ContentStyle:Constructor()
	self.Padding = {
		["Left"] = 0,  ["Top"] = 0, 
		["Right"] = 0, ["Bottom"] = 0
	};

	self.BackColor = 0;

	self.Size = {
		["MinimumWidth"] = 0, ["MinimumHeight"] = 0, 
		["MaximumWidth"] = 0, ["MaximumHeight"] = 0, 
		["DynamicWidth"] = 0, ["DynamicHeight"] = 0
	};

	self.VerticalAlignment = VerticalAlignment.None;
	self.HorizontalAlignment = HorizontalAlignment.None;
end

function ContentStyle:SetPadding(left, top, right, bottom)
	self.Padding.Left = left;
	self.Padding.Top = top or left;
	self.Padding.Right = right or left;
	self.Padding.Bottom = bottom or left;
end

function ContentStyle:SetBackColor(color)
	self.BackColor = color;
end

function ContentStyle:SetMinimumSize(minWidth, minHeight)
	self.Size.MinimumWidth = minWidth;
	self.Size.MinimumHeight = minHeight;
end

function ContentStyle:SetDynamicSize(dynamicWidth, dynamicHeight)
	self.Size.DynamicWidth = dynamicWidth;
	self.Size.DynamicHeight = dynamicHeight;
end

function _G.RandomContentStyle()
	local contentStyle = ContentStyle();

	contentStyle:SetPadding(6, 6, 6, 6);
	contentStyle:SetBackColor(Turbine.UI.Color(0.8, math.random(), math.random(), math.random()));

	return contentStyle;
end
