
Fonts = {
	["RegisteredFontData"] = {},
	["DefaultLotroFont"] = Turbine.UI.Lotro.Font.Verdana14,
};

function Fonts.PointToPixel(point)
	--return math.floor(point * 96 / 72 + 0.5);
	return point;
end

Fonts.FontPixelHeights = {
	[Turbine.UI.Lotro.Font.Arial12] = Fonts.PointToPixel(12),

	[Turbine.UI.Lotro.Font.TrajanPro13] = Fonts.PointToPixel(13),
	[Turbine.UI.Lotro.Font.TrajanPro14] = Fonts.PointToPixel(14),
	[Turbine.UI.Lotro.Font.TrajanPro15] = Fonts.PointToPixel(15),
	[Turbine.UI.Lotro.Font.TrajanPro16] = Fonts.PointToPixel(16),
	[Turbine.UI.Lotro.Font.TrajanPro18] = Fonts.PointToPixel(18),
	[Turbine.UI.Lotro.Font.TrajanPro19] = Fonts.PointToPixel(19),
	[Turbine.UI.Lotro.Font.TrajanPro20] = Fonts.PointToPixel(20),
	[Turbine.UI.Lotro.Font.TrajanPro21] = Fonts.PointToPixel(21),
	[Turbine.UI.Lotro.Font.TrajanPro23] = Fonts.PointToPixel(23),
	[Turbine.UI.Lotro.Font.TrajanPro24] = Fonts.PointToPixel(24),
	[Turbine.UI.Lotro.Font.TrajanPro25] = Fonts.PointToPixel(25),
	[Turbine.UI.Lotro.Font.TrajanPro26] = Fonts.PointToPixel(26),
	[Turbine.UI.Lotro.Font.TrajanPro28] = Fonts.PointToPixel(28),
	
	[Turbine.UI.Lotro.Font.TrajanProBold16] = Fonts.PointToPixel(16),
	[Turbine.UI.Lotro.Font.TrajanProBold22] = Fonts.PointToPixel(22),
	[Turbine.UI.Lotro.Font.TrajanProBold24] = Fonts.PointToPixel(24),
	[Turbine.UI.Lotro.Font.TrajanProBold25] = Fonts.PointToPixel(25),
	[Turbine.UI.Lotro.Font.TrajanProBold30] = Fonts.PointToPixel(30),
	[Turbine.UI.Lotro.Font.TrajanProBold36] = Fonts.PointToPixel(36),

	[Turbine.UI.Lotro.Font.Verdana10] = Fonts.PointToPixel(10),
	[Turbine.UI.Lotro.Font.Verdana12] = Fonts.PointToPixel(12),
	[Turbine.UI.Lotro.Font.Verdana14] = Fonts.PointToPixel(14),
	[Turbine.UI.Lotro.Font.Verdana16] = Fonts.PointToPixel(16),
	[Turbine.UI.Lotro.Font.Verdana18] = Fonts.PointToPixel(18),
	[Turbine.UI.Lotro.Font.Verdana20] = Fonts.PointToPixel(20),
	[Turbine.UI.Lotro.Font.Verdana22] = Fonts.PointToPixel(22),
	[Turbine.UI.Lotro.Font.Verdana23] = Fonts.PointToPixel(23),
};

function Fonts.GetFontHeight(lotroFont)
	return math.max(12, Fonts.FontPixelHeights[lotroFont] or 0);
end

function Fonts.AddFontData(fontData)
	fontData.FontHeight = Fonts.GetFontHeight(fontData.LotroFont);
	Fonts.RegisteredFontData[fontData.LotroFont] = fontData;
end

function Fonts.GetFontData(lotroFont)
	return Fonts.RegisteredFontData[lotroFont];
end
