
_G.ScrollPanel = class(LayoutBase);

function ScrollPanel:Constructor()
	LayoutBase.Constructor(self);

	-- content
	local content = TemplateLoader.Setup(self, self:GetTemplate());
	content:SetParent(self);
	self.Content = content;

	self.ScrollViewer.InternalListBox:SetVerticalScrollBar(self.VerticalScrollbar);
	self.ScrollViewer.InternalListBox:SetHorizontalScrollBar(self.HorizontalScrollbar);
end

function ScrollPanel:SetContent(control)
	return self.ScrollViewer:SetContent(control);
end

function ScrollPanel:Layout()
	self.Panel:SetSize(self:GetSize());
	self.Panel:PerformLayout();
	self:SetSize(self.Panel:GetSize());
	--self:PerformLayout();
end

function ScrollPanel:GetTemplate(bindings)
	return {
		["Type"] = StackPanel,
		["Name"] = "Panel",
		["Content"] =
		{
			{
				["Type"] = StackPanel,
				["IsVertical"] = false,
				["Content.DynamicHeight"] = 1,
				["Content"] =
				{
					{
						["Type"] = ScrollViewer,
						["Name"] = "ScrollViewer",
						["Content.DynamicWidth"] = 1,
						["Content"] = 
						{
						},
					},
					{
						["Type"] = Turbine.UI.Lotro.ScrollBar,
						["Name"] = "VerticalScrollbar",
						["Width"] = 10,
						["Orientation"] = Turbine.UI.Orientation.Vertical,
					},
				},
			},
			{
				["Type"] = StackPanel,
				["IsVertical"] = false,
				["Content"] =
				{
					{
						["Type"] = Turbine.UI.Lotro.ScrollBar,
						["Name"] = "HorizontalScrollbar",
						["Height"] = 10,
						["Orientation"] = Turbine.UI.Orientation.Horizontal,
						["Content.DynamicWidth"] = 1,
					},
					{
						["Type"] = Turbine.UI.Label,
						["Width"] = 10,
						["Height"] = 10,
					},
				},
			},
		},
	};
end