
_G.Task = class();

function Task:Constructor(action, delay)
	self._items = {};
	self._size = 0;
	self._count = 0;
	self._timestamp = 0;
	self._active = false;
	self._activeitem = nil;
	self._control = Turbine.UI.Control();

	local task = self;

	self._control.Update = function(args)
		if Turbine.Engine:GetGameTime() - task._timestamp > task._activeitem.delay then
			task._count = task._count + 1;
			task._activeitem.action(task);

			if not (task._count < task._size) then
				self:Cancel();
				return;
			end

			task._activeitem = task._items[task._count];
			self._timestamp = Turbine.Engine:GetGameTime();
		end
	end

	self:ContinueWith(action, delay);
end

function Task:ContinueWith(action, delay)
	if self._active then
		Turbine.Shell.WriteLine("you cannot add an action while the task is running");
		return self;
	end

	if action == nil then
		return self;
	end

	self._items[self._size] = {
		["action"] = action,
		["delay"]  = delay or 0.01,
	};

	self._size = self._size + 1;

	return self;
end

function Task:Cancel()
	self._control:SetWantsUpdates(false);
	self._active = false;
	return self;
end

function Task:Start()
	if self._active then
		Turbine.Shell.WriteLine("the task is always running");
		return self;
	end

	if self._size < 1 then
		return self;
	end

	self._active = true;
	self._activeitem = self._items[0];
	self._count = 0;
	self._timestamp = Turbine.Engine:GetGameTime();
	self._control:SetWantsUpdates(true);

	return self;
end

function Task:IsRunning()
	return self._active;
end
