
_G.TemplateLoader = class();

TemplateLoader.Setters = {
	["AUTOSIZE"] = function(self, control, value)
		-- TextBlock
		control:SetAutoSize(value);
	end,
	["BACKCOLOR"] = function(self, control, value)
		-- Control
		control:SetBackColor(value);
	end,
	["BACKGROUND"] = function(self, control, value)
		-- Control
		control:SetBackground(value);
	end,
	["BACKCOLORBLENDMODE"] = function(self, control, value)
		-- Control
		control:SetBackground(value);
	end,
	["BLENDMODE"] = function(self, control, value)
		-- Control, Image
		control:SetBlendMode(value);
	end,
	["BORDERWIDTH"] = function(self, control, value)
		-- Border, Button
		control:SetBorderWidth(value);
	end,
	["BORDERCOLOR"] = function(self, control, value)
		-- Border, Button
		control:SetBorderColor(value);
	end,
	["CHECKED"] = function(self, control, value)
		-- CheckBox
		control:SetChecked(value);
	end,
	["CHECKEDCHANGED"] = function(self, control, value)
		-- CheckBox
		Events.AddCallback(control, "CheckedChanged", value);
	end,
	["CLICK"] = function(self, control, value)
		-- Button
		Events.AddCallback(control, "Click", value);
	end,
	["DYNAMICHEIGHT"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Size.DynamicHeight = value;
	end,
	["DYNAMICWIDTH"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Size.DynamicWidth = value;
	end,
	["ENABLEDCHANGED"] = function(self, control, value)
		-- Control
		Events.AddCallback(control, "EnabledChanged", value);
	end,
	["FITTOCONTENT"] = function(self, control, value)
		-- FlowPanel, StackPanel
		control:SetFitToContent(value);
	end,
	["FONT"] = function(self, control, value)
		-- Label
		control:SetFont(value);
	end,
	["FONTSTYLE"] = function(self, control, value)
		-- Label
		control:SetFontStyle(value);
	end,
	["FORECOLOR"] = function(self, control, value)
		-- Label
		control:SetForeColor(value);
	end,
	["HEIGHT"] = function(self, control, value)
		-- Control
		control:SetHeight(value);
	end,
	["HORIZONTALALIGNMENT"] = function(self, control, value)
		-- ContentControl
		if control.ContentStyle then
			control.ContentStyle.HorizontalAlignment = value;
			return;
		end

		-- Image
		control:SetHorizontalAlignment(value);
	end,
	["IMAGEBACKCOLOR"] = function(self, control, value)
		-- Image
		control:SetImageBackColor(value);
	end,
	["IMAGEMODE"] = function(self, control, value)
		-- Image
		control:SetImageMode(value);
	end,
	["ISVERTICAL"] = function(self, control, value)
		-- StackPanel
		control.IsVertical = value;
	end,
	["LARGECHANGE"] = function(self, control, value)
		-- ScrollBar
		control:SetLargeChange(value);
	end,
	["MARKUPENABLED"] = function(self, control, value)
		-- Label
		control:SetMarkupEnabled(value);
	end,
	["MAXIMUM"] = function(self, control, value)
		-- ScrollBar
		control:SetMaximum(value);
	end,
	["MAXHEIGHT"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Size.MaximumHeight = value;
	end,
	["MAXWIDTH"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Size.MaximumWidth = value;
	end,
	["MINIMUM"] = function(self, control, value)
		-- ScrollBar
		control:SetMinimum(value);
	end,
	["MINHEIGHT"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Size.MinimumHeight = value;
	end,
	["MINWIDTH"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Size.MinimumWidth = value;
	end,
	["MOUSECLICK"] = function(self, control, value)
		-- Control
		Events.AddCallback(control, "MouseClick", value);
	end,
	["MOUSEDOWN"] = function(self, control, value)
		-- Control
		Events.AddCallback(control, "MouseDown", value);
	end,
	["MOUSEDOWNCOLOR"] = function(self, control, value)
		-- Button
		control:SetMouseDownColor(value);
	end,
	["MOUSEENTER"] = function(self, control, value)
		-- Control
		Events.AddCallback(control, "MouseEnter", value);
	end,
	["MOUSEENTERCOLOR"] = function(self, control, value)
		-- Button
		control:SetMouseEnterColor(value);
	end,
	["MOUSELEAVE"] = function(self, control, value)
		-- Control
		Events.AddCallback(control, "MouseLeave", value);
	end,
	["MOUSELEAVECOLOR"] = function(self, control, value)
		-- Button
		control:SetMouseLeaveColor(value);
	end,
	["MOUSEMOVE"] = function(self, control, value)
		-- Control
		Events.AddCallback(control, "MouseMove", value);
	end,
	["MOUSEUP"] = function(self, control, value)
		-- Control
		Events.AddCallback(control, "MouseUp", value);
	end,
	["MULTILINE"] = function(self, control, value)
		-- Label
		control:SetMultiline(value);
	end,
	["NAME"] = function(self, control, value)
		self[value] = control;
	end,
	["ORIENTATION"] = function(self, control, value)
		-- ScrollBar
		control:SetOrientation(value);
	end,
	["OUTLINECOLOR"] = function(self, control, value)
		-- Label, TextBlock
		control:SetOutlineColor(value);
	end,
	["PADDING"] = function(self, control, value)
		-- ContentControl
		control:SetPadding(value);
		--control.ContentStyle.Padding.Left   = value;
		--control.ContentStyle.Padding.Top    = value;
		--control.ContentStyle.Padding.Right  = value;
		--control.ContentStyle.Padding.Bottom = value;
	end,
	["PADDINGBOTTOM"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Padding.Bottom = value;
	end,
	["PADDINGLEFT"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Padding.Left = value;
	end,
	["PADDINGRIGHT"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Padding.Right = value;
	end,
	["PADDINGTOP"] = function(self, control, value)
		-- ContentControl
		control.ContentStyle.Padding.Top = value;
	end,
	["SCROLLBARCOLOR"] = function(self, control, value)
		-- TextBlock
		control:SetScrollbarColor(value);
	end,
	["SELECTABLE"] = function(self, control, value)
		-- Label
		control:SetSelectable(value);
	end,
	["SMALLCHANGE"] = function(self, control, value)
		-- ScrollBar
		control:SetSmallChange(value);
	end,
	["STYLE"] = function(self, control, value)
		-- ContentControl
		control:ApplyContentStyle(value);
	end,
	["TAG"] = function(self, control, value)
		-- Add a custom tag item
		control["Tag"] = value;
	end,
	["TEXT"] = function(self, control, value)
		-- Label, Button
		control:SetText(value);
	end,
	["TEXTALIGNMENT"] = function(self, control, value)
		-- Label
		control:SetTextAlignment(value);
	end,
	["TEXTPADDING"] = function(self, control, value)
		-- TextBlock
		control:SetTextPadding(value);
	end,
	["VALUE"] = function(self, control, value)
		-- ScrollBar
		control:SetValue(value);
	end,
	["VALUECHANGED"] = function(self, control, value)
		-- ScrollBar
		Events.AddCallback(control, "ValueChanged", value);
	end,
	["VERTICALALIGNMENT"] = function(self, control, value)
		-- ContentControl
		if control.ContentStyle then
			control.ContentStyle.VerticalAlignment = value;
			return;
		end
		
		-- Image
		control:SetVerticalAlignment(value);
	end,
	["VISIBLE"] = function(self, control, value)
		-- Control
		control:SetVisible(value);
	end,
	["WIDTH"] = function(self, control, value)
		-- Control
		control:SetWidth(value);
	end,
	["ZORDER"] = function(self, control, value)
		-- Control
		control:SetZOrder(value);
	end,
};

-- process the control definition, creates the control
function TemplateLoader.Setup(self, definition)
	local control = nil;
	local content = nil;

	-- bootstrap
	for k, v in pairs(definition) do
		local key = string.upper(k);
		
		if key == "TYPE" then
			control = v();
		end

		if key == "CONTENT" then
			content = v;
		end
	end

	if control == nil then
		Turbine.Shell.WriteLine("TemplateLoader: control is nil");
		return;
	end;

	-- assign the values directly to the control, if available
	for k, v in pairs(definition) do
		local key = string.upper(k);
		local setter = TemplateLoader.Setters[string.upper(key)];

		if type(setter) == "function" then
			setter(self, control, v);
		else
			if 	key ~= "TYPE" and 
				key ~= "CONTENT" and 
				string.sub(key, 1, string.len("CONTENT.")) ~= "CONTENT." 
			then
				Turbine.Shell.WriteLine("TemplateLoader: setter not found: " .. key);
			end
		end
	end

	-- process the content definition
	TemplateLoader.InternalProcessContent(self, control, content);

	return control;
end

-- process the content definition
function TemplateLoader.InternalProcessContent(self, control, content)
	if content == nil then
		return;
	end;

	for _, v in pairs(content) do
		-- create the cild control
		local child = TemplateLoader.Setup(self, v);
		local contentControl;

		-- wraps the child control into an content control (ContentControl)
		if type(control.AddControl) == "function" then
			-- some panels can have more then one child
			contentControl = control:AddControl(child);
		else
			-- some panels can have only one child, currently the latest child wins, if more than one are present
			contentControl = control:SetContent(child);
		end

		-- process the content content control
		TemplateLoader.InternalProcessContentControl(self, v, contentControl);
	end
end

-- process the content content control
function TemplateLoader.InternalProcessContentControl(self, definition, contentControl)
	if contentControl == nil then
		return;
	end;

	-- CONTENT.STYLE vs. CONTENT.DYNAMICHEIGHT, CONTENT.DYNAMICWIDTH as a part of CONTENT.STYLE

	-- process "CONTENT.STYLE" first! there is no highest qualified detection ... sorry
	for k, v in pairs(definition) do
		local key = string.upper(k);
		
		if key == "CONTENT.STYLE" then
			local setter = TemplateLoader.Setters["STYLE"];

			if type(setter) == "function" then
				setter(self, contentControl, v);
			else
				Turbine.Shell.WriteLine("TemplateLoader: setter not found: " .. key);
			end
		end
	end

	-- process all "CONTENT.XXX", except "CONTENT.STYLE" see previous
	for k, v in pairs(definition) do
		local key = string.upper(k);
		
		if string.sub(key, 1, string.len("CONTENT.")) == "CONTENT." then
			local setterKey = string.sub(key, string.len("CONTENT.") + 1);
			
			if setterKey ~= "STYLE" then
				local setter = TemplateLoader.Setters[string.upper(setterKey)];

				if type(setter) == "function" then
					setter(self, contentControl, v);
				else
					Turbine.Shell.WriteLine("TemplateLoader: setter not found: " .. key);
				end
			end
		end
	end
end
