
HelpWindow = class(BaseWindow);

function HelpWindow:Constructor(filterEngine)
	BaseWindow.Constructor(self);

	local content = TemplateLoader.Setup(self, self:GetTemplate(bindings));
	self:SetContent(content);
	self:SetText("Hilfe");
	self:FitToContent();
end

function HelpWindow:GetTemplate(bindings)
	return {
		["Type"] = Border,
		["BorderWidth"] = 1,
		["Width"] = 650,
		["Height"] = 500,
		["BackColor"] = Turbine.UI.Color(0.3, 0.3, 0),
		["BorderColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
		["Content"] =
		{
			{
				["Type"] = Image,
				["ImageMode"] = ImageMode.KeepImage,
				["Background"] = Images.Pocket,
				["BlendMode"] = Turbine.UI.BlendMode.Multiply,
				["HorizontalAlignment"] = HorizontalAlignment.Center,
				["VerticalAlignment"] = VerticalAlignment.Center,
				["Content"] =
				{
					{
						["Type"] = ScrollViewer,
						["Content"] =
						{
							{
								["Type"] = FlowPanel,
								["Content.Padding"] = 10,
								["Content"] = 
								{
									{
										["Type"] = StackPanel,
										["Content.MaxWidth"] = 600,
										["Content.Padding"] = 10,
										["Content"] =
										{
											{
												["Type"] = TextBlock,
												["Text"] = "1. Erstelle eine neue Registerkarte",
												["Content.Padding"] = {Left = 0, Top = 10, Right = 10, Bottom = 10},
											},
											{
												["Type"] = Image,
												["Background"] = Images.TabCreate,
												["Content.BackColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
												["Content.Padding"] = 4,
											},
										},
									},
									{
										["Type"] = StackPanel,
										["Content.MaxWidth"] = 600,
										["Content.Padding"] = 10,
										["Content"] =
										{
											{
												["Type"] = TextBlock,
												["Text"] = "2. Benenne die neue Registerkarte um, zum Beispiel 'unfiltered'",
												["Content.Padding"] = {Left = 0, Top = 10, Right = 10, Bottom = 10},
											},
											{
												["Type"] = Image,
												["Background"] = Images.TabRename,
												["Content.BackColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
												["Content.Padding"] = 4,
											},
											{
												["Type"] = TextBlock,
												["Text"] = "Der Name ist frei wählbar und nicht von Bedeutung.",
												["Content.Padding"] = {Left = 0, Top = 10, Right = 10, Bottom = 10},
											},
											{
												["Type"] = Image,
												["Background"] = Images.TabRenamed,
												["Content.BackColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
												["Content.Padding"] = 4,
											},
										},
									},
									{
										["Type"] = StackPanel,
										["Content.MaxWidth"] = 600,
										["Content.Padding"] = 10,
										["Content"] =
										{
											{
												["Type"] = TextBlock,
												["Text"] = "3. Aktiviere für die neue Registerkarte die Kanäle [Welt] und [Handeln]. Alle anderen Kanäle sollten hier deaktiviert sein.",
												["Content.Padding"] = {Left = 0, Top = 10, Right = 10, Bottom = 10},
											},
											{
												["Type"] = Image,
												["Background"] = Images.TabChannels,
												["Content.BackColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
												["Content.Padding"] = 4,
											},
										},
									},
									{
										["Type"] = StackPanel,
										["Content.MaxWidth"] = 600,
										["Content.Padding"] = 10,
										["Content"] =
										{
											{
												["Type"] = TextBlock,
												["Text"] = "4. Deaktiviere für die allgemeine Registerkarte die Kanäle [Welt] und [Handeln]. Alle anderen Kanäle belasse so wie sie gerade eingestellt sind.",
												["Content.Padding"] = {Left = 0, Top = 10, Right = 10, Bottom = 10},
											},
											{
												["Type"] = Image,
												["Background"] = Images.TabCommon,
												["Content.BackColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
												["Content.Padding"] = 4,
											},
										},
									},
									{
										["Type"] = StackPanel,
										["Content.MaxWidth"] = 600,
										["Content.Padding"] = 10,
										["Content"] =
										{
											{
												["Type"] = TextBlock,
												["Text"] = "Jetzt kann das Plugin die Nachrichten aus den Kanälen [Welt] und [Handeln] empfangen und gefiltert auf der allgemeinen Registerkarte ausgeben. Um das Plugin automatisch zu laden, öffne den Zusatzmodule-Manger.",
												["Content.Padding"] = {Left = 0, Top = 10, Right = 10, Bottom = 10},
											},
											{
												["Type"] = Image,
												["Background"] = Images.PluginManager,
												["Content.BackColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
												["Content.Padding"] = 4,
											},
										},
									},
									{
										["Type"] = StackPanel,
										["Content.MaxWidth"] = 600,
										["Content.Padding"] = 10,
										["Content"] =
										{
											{
												["Type"] = TextBlock,
												["Text"] = "Wähle nun die Option automatisch laden für 'Alle Charaktere'. Der Filter wird nun immer beim Betreten der Spielewelt geladen. Die Registerkarten müssen aber für jeden Charakter einmalig eingestellt werden.",
												["Content.Padding"] = {Left = 0, Top = 10, Right = 10, Bottom = 10},
											},
											{
												["Type"] = Image,
												["Background"] = Images.PluginLoad,
												["Content.BackColor"] = Turbine.UI.Color(0.98, 0.4, 0.4, 0.0);
												["Content.Padding"] = 4,
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
	};
end
