local path = getfenv(1)._.Name;

import "Turbine";
import "Turbine.Gameplay";

-- keep the order
import (path .. ".utf8");
import (path .. ".utf8upperMap");
import (path .. ".utf8lowerMap");
import (path .. ".Locale");
import (path .. ".Strings");
import (path .. ".ChatType");
import (path .. ".FilterData");
import (path .. ".Settings");
import (path .. ".Policies");
import (path .. ".FilterEngine");
import (path .. ".ShellCommand");
import (path .. ".ShellCommandHandler");
import (path .. ".SpamFilter");
import (path .. ".UI");
import (path .. ".Main");

-- See plugin information file
local pluginInfo = plugin:GetName() .. " (" .. plugin:GetAuthor() .. ") " .. plugin:GetVersion();
local main = Main();

function Turbine.Plugin:Load(args)
	Turbine.Shell.WriteLine(pluginInfo .. " loaded ");
	main:OnLoad();
end

function Turbine.Plugin:Unload(args)
	main:OnUnload();
	Turbine.Shell.WriteLine(pluginInfo .. " unloaded");
end

function Turbine.Chat:Received(args)
	main:OnChatMessage(args.Message, args.ChatType);
end

function Turbine.Plugin:GetOptionsPanel()
	-- can be called multiple time
	return main:GetOptionsPanel();
end
